# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section free

Name:        activesoap
Summary:     A high performance, lightweight, StAX based SOAP framework
Url:         http://xircles.codehaus.org/projects/activesoap
Version:     1.0
Release:     3%{?dist}
Epoch:       0
License:     Apache Software License 2.0
Group:       Development/Libraries/Java
Source0:     http://dist.codehaus.org/activesoap/distributions/activesoap-1.0-SNAPSHOT-src.tar.gz

Source4:     activesoap-1.0-jpp-depmap.xml
Patch0:      activesoap-1.0-project_xml.patch
Patch1:      activesoap-1.0-XMLStreamHelper.patch
Patch2:      activesoap-1.0-SAXHandler.patch
Patch3:      activesoap-1.0-project_properties.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-report-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-one
BuildRequires:  maven2-plugin-resources
BuildRequires:  apache-commons-parent

BuildRequires:  junit
BuildRequires:  axis
BuildRequires:  bea-stax-api
BuildRequires:  concurrent
BuildRequires:  geronimo-j2ee-1.4-apis
BuildRequires:  apache-commons-logging
BuildRequires:  jetty5
BuildRequires:  servletapi5
BuildRequires:  spring-all
BuildRequires:  stax-utils
BuildRequires:  tomcat5-jasper
BuildRequires:  wsdl4j
BuildRequires:  ws-wsif
BuildRequires:  wstx
BuildRequires:  xmlbeans
BuildRequires:  xml-commons-apis
BuildRequires:  xstream
Requires:  axis
Requires:  bea-stax-api
Requires:  jms_1_1_api
Requires:  apache-commons-logging
Requires:  jetty5
Requires:  servlet_2_3_api
Requires:  stax-utils
Requires:  wsdl4j
Requires:  ws-wsif
Requires:  xmlbeans
Requires:  xstream

%if %{gcj_support}
BuildRequires:    gnu-crypto
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:  %{_tmppath}/%{name}-%{version}-buildroot

%description
ActiveSOAP is a lightweight & easily embeddable REST and SOAP
stack based on StAX with support for WS-Addressing and WSIF.
ActiveSOAP uses StAX (the Standard API for pull parsing) to
implement the SOAP protocols and then it delegates to plugin
Handler objects for the heavy duty processing of the XML
payloads. This means that you only need to pay for what you
need; use fast pull based event parsing or full data binding
mechanisms like JAXB or XStream or DOMish APIs like XMLBeans
when they make sense.
You can use whatever XML marshalling and/or parsing tool you
like to process different messages or headers. The following
APIs are currently supported
* JAXB
* XMLBeans
* XStream
* StaX, SAX, DOM or TrAX
ActiveSOAP is currently used to provide WS-Notification support
in ServiceMix.
In addition to the core StAX processing of SOAP requests (client
and server side) ActiveSOAP provides support for WS-Addressing
and provides multiple WSIF providers.


%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n %{name}-%{version}-SNAPSHOT

chmod -R go=u-w *
for f in $(find . -name "*.jar"); do
  mv $f $f.no
#  rm $f
done

%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p ${MAVEN_REPO_LOCAL}
%{_bindir}/mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Dmaven2.jpp.depmap.file=%{SOURCE4} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        one:convert

%{_bindir}/mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Dmaven2.jpp.depmap.file=%{SOURCE4} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven.test.skip=true \
        install javadoc:javadoc


%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}

install -m 644 target/%{name}-%{version}-SNAPSHOT.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root)
%doc LICENSE.txt
%{_javadir}/*
%if %{gcj_support}
%attr(-,root,root) %dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Fri Jul 08 2011 Ralph Apel <r.apel at r-apel.de> 0:1.0-3
- Build with maven2 for JPP-6

* Mon May 21 2007 Ralph Apel <r.apel at r-apel.de> 0:1.0-2jpp
- Fix project.xml syntax
- Improve description
- Make Vendor, Distribution based on macro
- Fix aot build

* Tue Oct 17 2006 Ralph Apel <r.apel at r-apel.de> 0:1.0-1jpp
- First release
- Add gcj_support option
- Add javadoc post/postun Requires
